
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 450
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_ARB_shader_draw_parameters : require
#extension GL_ARB_shader_ballot : require

out float gl_ClipDistance[1];

invariant gl_Position;

struct unaligned_float3
{
    float x;
    float y;
    float z;
};

struct S_TBN
{
    int _iNormal;
    int _iTangent;
};

struct S_INDICES
{
    uint _uiObjectIndex;
    uint _uiMaterialIndex;
    uint _uiMaterialInstanceIndex;
    uint _uiLastFrameMaterialIndex;
    uint _uiLastFrameMaterialInstanceIndex;
    uint _uiPositionsBufferIndex;
    uint _uiPrevPositionsBufferIndex;
    uint _uiNormalsBufferIndex;
    uint _uiPositionOffset;
    uint _uiPrevPositionOffset;
    uint _uiNormalOffset;
    uint _uiMatricesIndex;
};

struct S_MAIN_DEFAULT
{
    S_INDICES _Indices;
};

struct S_MAIN_DEFAULT_ARRAY
{
    S_MAIN_DEFAULT _aMain[32];
};

struct S_MESH_OBJECT
{
    mat4 _mModel;
    mat4 _mModelLast;
    mat4 _mInvModel;
    mat4 _mInvModelLast;
    vec4 _vDiversityOffset;
    uint _uiSceneZoneIndex;
    uint _uiNeighborSceneZoneIndex;
    uint _uiDisplayFlags;
    uint _uiPackedLocalExposureCompensation;
    vec4 _vPortalDirAndDistance;
    int _iPickingID[2];
    float _fLocalExposureCompensation;
    float _fLocalExposureCompensationEV100;
};

struct S_MATERIAL
{
    vec4 _vErrorColor;
    float _fDepthBias;
    float _fDummy0;
    float _fDummy1;
    float _fDummy2;
    float c0;
    float c1;
    float c2;
    float c3;
    uint s0;
    uint s1;
    uint s2;
    uint s3;
    uint s4;
    uint s5;
    uint s6;
    uint s7;
    uint s8;
    uint s9;
    uint s10;
    uint s11;
    uint s12;
    uint s13;
    uint s14;
    uint s15;
    uint s16;
    uint s17;
    uint s18;
    uint s19;
};

struct S_MATERIAL_INSTANCE
{
    float c0;
    float c1;
    float c2;
    float c3;
    float c4;
    float c5;
    float c6;
    float c7;
    float _fGloubiboulga;
};

struct S_PASS_MATRICES
{
    mat4 _mViewJitteredProj;
    mat4 _mViewProj;
    mat4 _mView;
    mat4 _mInvView;
    mat4 _mJitteredProj;
};

struct S_EYE_DATA
{
    S_PASS_MATRICES _mCurrentFrameMatrices[2];
    S_PASS_MATRICES _mPreviousFrameMatrices[2];
    mat4 _mJitteredProjection[2];
    mat4 _mNoJitterProjection[2];
    mat4 _mInvViewJitteredProj[2];
    vec4 _vWorldSpaceCameraVector[2];
    vec4 _vWorldSpaceCameraPosition[2];
    vec4 _vFrameBufferScale;
    vec4 _vFrameBufferViewportSize;
    vec4 _vFrameBufferOneOnViewportSize;
    vec4 _vViewportSize;
    vec4 _vFogSubCrop;
    uint _uiAlignment0;
    uint _uiAlignment1;
    float _vCameraJitterDeltaX;
    float _vCameraJitterDeltaY;
    vec4 _vfRcpFVolumetricFogDepthTileSize;
};

struct S_CASCADED_SHADOW
{
    mat4 _mCascadeMatrix[2][8];
    mat4 _mViewSpaceToStaticShadowMapSpace[2];
    vec4 _vfCascadeShadowAttenuation;
    vec4 _vfShadowCascadeTextureTexelSize;
    vec4 _vfStaticShadowBlurRadius;
    vec4 _vfCascadeLinearZProjFactors[8];
    vec4 _vfCascadeParams[8];
};

struct S_CLUSTER_LIGHT_SETUP
{
    S_CASCADED_SHADOW _CascadedShadow;
    vec4 _vfSkinUVParamsAndNormalBias;
    vec4 _vfShadowTextureTexelSize;
    vec4 _vfDummy_SkinFresnelF0AndF90;
    uint _uiCascadedUsed;
    float _fSSSWidth;
    float _fOffsetBias;
    float _fDummy;
};

struct S_CLUSTER_INFO
{
    mat4 _mViewToClusterView[2];
    mat4 _mClusterProjMatrix;
    mat4 _mClusterInvProjMatrix;
    vec4 _vfLeftEyeToCombinedEyeVsDeltaXZ;
    uint _uiFinestMipWidth;
    uint _uiFinestMipHeight;
    uint _uiFinestMipDepth;
    uint _uiFinestMipWidthHeight;
    float _fZSliceGeomFactor;
    float _fRcpLogZSliceGeomFactor;
    float _fDummy0;
    float _fDummy1;
    float _fNearP;
    float _fInvNearP;
    float _fFarP;
    float _fClusterCoincidentWithCamera;
};

struct S_PASS
{
    S_EYE_DATA _EyeData;
    vec4 _avFrustumCorners[4];
    vec4 _vTime;
    vec4 _cFogColor;
    vec4 _vFogSetup;
    vec4 _cSunColor;
    vec4 _vSunDir;
    vec4 _vProjectionSetup;
    vec4 _vProjectionCoeff;
    vec4 _vOutputColor;
    vec4 _vfVsClippingPlane[2];
    S_CLUSTER_LIGHT_SETUP _LightSetup;
    S_CLUSTER_INFO _ClusterInfo;
    float _fIBLIntensity;
    float _fGIIntensity;
    float _fAmbiantOcclusionDirectIntensity;
    float _fAmbiantOcclusionIndirectIntensity;
    float _fNormalSign;
    int _iFogType;
    float _fSelfOcclusionDebugRatio;
    float _fEmissive;
    int _iEnableSkinSSSSS;
    int _iUseHairOpaquePrepass;
    float _fLocalSceneExposure;
    uint _uiDebugMode;
    uint _sFlags;
    float _fTAADropsSharpness;
    uint _uNeoScaleX;
    uint _uNeoScaleY;
    uint _uiDirectOverdrawFilter;
    float _fCoderTest0;
    float _fCoderTest1;
    float _fCoderTest2;
    uint _uiBakeOutput;
    float _fDefaultAmbientIntensity;
    float _fDefaultLightingIntensity;
    uint _uiOutputColor;
    float _fAARotation;
    float _fClampDirectSpecular;
    float _fNearPlane;
    float _fFarPlane;
    float _fNDFFilteringScreenSpaceVariance;
    float _fNDFFilteringThreshold;
    float _fNDFFilteringScreenSpaceVariance_EyeShader;
    float _fNDFFilteringThreshold_EyeShader;
    float _fSurfaceGradientTextureFiltering;
    float _fZero;
    uint _uDepthClamp;
    uint _uiLightDebugMode;
    vec4 _vfFragCoordToDepthTexFactor;
    vec4 _vfFragCoordToDepthTexFactor_HalfRes;
    uint _uHdr;
    uint _uiDrawMayaSwatch;
    float _fEyeRoughnessBias;
    float _fDummy1;
};

layout(set = 1, binding = 39, std430) readonly buffer g_rbVertices_Layout
{
    unaligned_float3 g_rbVertices[];
} g_rbVertices_Buffer[];

layout(set = 1, binding = 40, std430) readonly buffer g_rbTBNs_Layout
{
    S_TBN g_rbTBNs[];
} g_rbTBNs_Buffer[];

layout(set = 0, binding = 52, std140) uniform dyn_CONSTANT_BUFFER_BLOCK_CB_S_MAIN_ARRAY_BINDING
{
    S_MAIN_DEFAULT_ARRAY g_cbMainArray;
} _1215;

layout(set = 1, binding = 33, std430) readonly buffer g_rbObjects_Layout
{
    S_MESH_OBJECT g_rbObjects[];
} g_rbObjects_Buffer[];

layout(set = 1, binding = 34, std430) readonly buffer g_rbMaterials_Layout
{
    S_MATERIAL g_rbMaterials[];
} g_rbMaterials_Buffer[];

layout(set = 1, binding = 35, std430) readonly buffer g_rbMaterialInstances_Layout
{
    S_MATERIAL_INSTANCE g_rbMaterialInstances[];
} g_rbMaterialInstances_Buffer[];

layout(set = 2, binding = 53, std140) uniform dyn_CONSTANT_BUFFER_BLOCK_CB_S_PASS_BINDING
{
    S_PASS g_cbPass;
} _1511;

layout(set = 1, binding = 12) uniform sampler2D g_rb2DTextures[];

layout(location = 8) in vec2 in_uv0;
layout(location = 23) out float interp_instanceID;

vec3 _7853;

void main()
{
    int _1205 = gl_InstanceIndex + gl_DrawIDARB;
    int _1206 = readFirstInvocationARB(_1205);
    uint _3168 = uint(gl_VertexIndex);
    uint _3171 = _3168 + _1215.g_cbMainArray._aMain[_1206]._Indices._uiPositionOffset;
    uint _3191 = _3168 + _1215.g_cbMainArray._aMain[_1206]._Indices._uiNormalOffset;
    int _3220 = g_rbTBNs_Buffer[_1215.g_cbMainArray._aMain[_1206]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3191]._iNormal & 1023;
    int _3223 = (g_rbTBNs_Buffer[_1215.g_cbMainArray._aMain[_1206]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3191]._iNormal >> 10) & 1023;
    int _3226 = (g_rbTBNs_Buffer[_1215.g_cbMainArray._aMain[_1206]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3191]._iNormal >> 20) & 1023;
    int _7840;
    if (_3220 > 512)
    {
        _7840 = _3220 | (-1024);
    }
    else
    {
        _7840 = _3220;
    }
    int _7842;
    if (_3223 > 512)
    {
        _7842 = _3223 | (-1024);
    }
    else
    {
        _7842 = _3223;
    }
    int _7844;
    if (_3226 > 512)
    {
        _7844 = _3226 | (-1024);
    }
    else
    {
        _7844 = _3226;
    }
    float _3269 = float(_7840);
    float _3272 = float(_7842);
    float _3275 = float(_7844);
    vec3 _3276 = vec3(_3269, _3272, _3275);
    vec3 _3279 = _3276 * vec3(0.001956947147846221923828125);
    vec4 _3402 = vec4(g_rbVertices_Buffer[_1215.g_cbMainArray._aMain[_1206]._Indices._uiPositionsBufferIndex].g_rbVertices[_3171].x, g_rbVertices_Buffer[_1215.g_cbMainArray._aMain[_1206]._Indices._uiPositionsBufferIndex].g_rbVertices[_3171].y, g_rbVertices_Buffer[_1215.g_cbMainArray._aMain[_1206]._Indices._uiPositionsBufferIndex].g_rbVertices[_3171].z, 1.0);
    vec4 _3403 = g_rbObjects_Buffer[_1215.g_cbMainArray._aMain[_1206]._Indices._uiObjectIndex].g_rbObjects[0]._mModel * _3402;
    vec3 _3404 = _3403.xyz;
    mat3 _3561 = mat3(g_rbObjects_Buffer[_1215.g_cbMainArray._aMain[_1206]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[0].xyz, g_rbObjects_Buffer[_1215.g_cbMainArray._aMain[_1206]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[1].xyz, g_rbObjects_Buffer[_1215.g_cbMainArray._aMain[_1206]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[2].xyz);
    vec3 _3564 = _3561 * _3279;
    float _3779 = cos(-0.625999987125396728515625);
    float _3781 = sin(-0.625999987125396728515625);
    vec3 _7786 = _7853;
    _7786.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1215.g_cbMainArray._aMain[_1206]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], ((((in_uv0 - vec2(0.5, 0.13099999725818634033203125)) * mat2(vec2(_3779, _3781), vec2(-_3781, _3779))) + vec2(0.5, 0.13099999725818634033203125)) * vec2(-3.5, 5.0)) + vec2(2.1679999828338623046875, -0.12899999320507049560546875), 0.0).x;
    vec3 _3827 = vec3(g_rbMaterialInstances_Buffer[_1215.g_cbMainArray._aMain[_1206]._Indices._uiMaterialInstanceIndex].g_rbMaterialInstances[0].c0);
    vec3 _3830 = mod(_3827, vec3(2.0));
    vec3 _3834 = _7786 * _3830;
    vec2 _3845 = in_uv0 * vec2(3.0);
    vec3 _7795 = _7853;
    _7795.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1215.g_cbMainArray._aMain[_1206]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], _3845 + vec2(-0.20000000298023223876953125, -2.099999904632568359375), 0.0).y;
    vec3 _3864 = _3827 * vec3(0.100000001490116119384765625);
    vec3 _3867 = floor(_3864);
    vec3 _3871 = mod(_3867, vec3(2.0));
    vec3 _3875 = _7795 * _3871;
    vec3 _3879 = vec3(1.0) - _3834;
    vec3 _3882 = vec3(1.0) - _3875;
    vec3 _3883 = _3879 * _3882;
    vec3 _7804 = _7853;
    _7804.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1215.g_cbMainArray._aMain[_1206]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], _3845 + vec2(-0.941999971866607666015625, -0.007000000216066837310791015625), 0.0).z;
    vec3 _3915 = _3827 * vec3(0.00999999977648258209228515625);
    vec3 _3918 = floor(_3915);
    vec3 _3922 = mod(_3918, vec3(2.0));
    vec3 _3926 = _7804 * _3922;
    vec3 _3933 = vec3(1.0) - _3926;
    vec3 _3934 = _3883 * _3933;
    vec3 _3936 = vec3(1.0) - _3934;
    float _3938 = _3936.y;
    float _3943 = _3938 - 0.949999988079071044921875;
    float _3948 = _3943 * 19.9959964752197265625;
    float _3949 = clamp(_3948, 0.0, 1.0);
    float _3950 = mix(0.0, 1.0, _3949);
    float _3958 = _3938 - 0.88999998569488525390625;
    float _3963 = _3958 * 99.90019989013671875;
    float _3964 = clamp(_3963, 0.0, 1.0);
    float _3965 = mix(0.0, 1.0, _3964);
    vec3 _3970 = vec3(_3965);
    vec3 _3971 = mix(vec3(0.0), vec3(-0.011610000394284725189208984375), _3970);
    vec3 _3976 = vec3(_3950);
    vec3 _3977 = mix(_3971, vec3(-0.03869999945163726806640625), _3976);
    vec3 _3983 = _3977 * _3564;
    vec3 _3991 = vec3(g_rbMaterialInstances_Buffer[_1215.g_cbMainArray._aMain[_1206]._Indices._uiMaterialInstanceIndex].g_rbMaterialInstances[0].c1);
    vec3 _3992 = mix(vec3(0.0), _3983, _3991);
    vec3 _4015 = _3404 + _3992;
    float _4080 = _4015.x;
    float _4081 = _4015.y;
    float _4082 = _4015.z;
    vec4 _4083 = vec4(_4080, _4081, _4082, 1.0);
    vec4 _4084 = _1511.g_cbPass._EyeData._mCurrentFrameMatrices[0]._mView * _4083;
    vec4 _4100 = _1511.g_cbPass._EyeData._mCurrentFrameMatrices[0]._mViewJitteredProj * _4083;
    vec4 _7850;
    if (_1511.g_cbPass._uDepthClamp == 4294967295u)
    {
        float _4115 = _4100.w;
        vec4 _7851;
        if ((_4100.z / _4115) > 1.0)
        {
            vec4 _7852;
            if (_4084.z > _1511.g_cbPass._fNearPlane)
            {
                vec4 _7817 = _4100;
                _7817.z = _4115;
                _7852 = _7817;
            }
            else
            {
                _7852 = _4100;
            }
            _7851 = _7852;
        }
        else
        {
            _7851 = _4100;
        }
        _7850 = _7851;
    }
    else
    {
        _7850 = _4100;
    }
    interp_instanceID = float(_1205) + 0.5;
    float _3054 = _4084.x;
    float _3055 = _4084.y;
    float _3056 = _4084.z;
    vec4 _3057 = vec4(_3054, _3055, _3056, 1.0);
    float _3058 = dot(_1511.g_cbPass._vfVsClippingPlane[0], _3057);
    float _3059 = -_3058;
    gl_ClipDistance[0] = _3059;
    gl_Position = _7850;
}

